@echo off
rem Use OEM-866 (Cyrillic) encoding

setlocal EnableExtensions
setlocal EnableDelayedExpansion


set "AppName=TessaDesktopApp"
set "ExtName=Tessa.Extensions.Client"
set "Config=Release"
set "CopyParams=/Q /R /Y"

set "CurrentDir=%~dp0"
if "%CurrentDir:~-1%" == "\" (
    set "CurrentDir=%CurrentDir:~0,-1%"
)
set "SourcePath=%CurrentDir%"
pushd "%CurrentDir%"

:Start
cls

echo  ^> Building %AppName% and extensions

call :BuildApp %AppName% "%SourcePath%" "%SourcePath%\app\%AppName%32" win-x86
call :BuildApp %AppName% "%SourcePath%" "%SourcePath%\app\%AppName%" win-x64

echo;
echo  ^> Done. Press any key to quit...
pause>nul
cls

:Finish
popd
endlocal
goto :EOF


:BuildApp "name" "source" "target" "runtime"

rem name - имя exe-файла без расширения .exe
rem source - папка проекта с приложением
rem target - папка назначения
rem runtime - идентификатор RID: win-x64 или win-x86

rd /s /q "%~3\">nul 2>&1

cd /D "%~2"


dotnet publish "%~1.csproj" -c %Config% -r %~4 -o "%~3\"
for %%a in (cs, de, es, fr, it, ja, ko, pl, pt-BR, ru, tr, zh-Hans, zh-Hant) do rd /S /Q "%~3\%%a">nul 2>&1

dotnet publish "%SourcePath%\..\..\Extensions\%ExtName%\%ExtName%.csproj" -c %Config% -r "%~4" -o "%~3\%ExtName%"

for %%a in (
    "Tessa.Extensions.Default.Shared.dll",
    "Tessa.Extensions.Shared.dll",
    "Tessa.Extensions.Default.Client.dll",
    "Tessa.Extensions.Client.dll"
) do (
    echo F|xcopy "%~3\%ExtName%\%%~a" "%~3\extensions\%%~a" %CopyParams%>nul 2>&1
)

rd /s /q "%~3\%ExtName%"

goto :EOF