@echo off
rem Use OEM-866 (Cyrillic) encoding

setlocal EnableExtensions
setlocal EnableDelayedExpansion

set "Address=https://localhost/tessa"

set "Login="
set "Password="
set "Connection=default"
set "CheckTimeout=20"

set "Tools=C:\tessa\tadmin"

set "AppName=TessaDesktopApp"

set "CurrentDir=%~dp0"
if "%CurrentDir:~-1%" == "\" (
    set "CurrentDir=%CurrentDir:~0,-1%"
)
set "Applications=%CurrentDir%\app"

cd /d "%Tools%"

:Start
cls
echo This script will publish %AppName%
echo;
echo Please check connection string prior to publication in configuration file:
echo %Tools%\app.json
echo;
echo [Address] = %Address%
echo;
echo Press any key to begin pulication...
pause>nul

cls
echo Publishing %AppName%
echo;
echo [Address] = %Address%

echo  ^> Checking connection to web service
tadmin CheckService "/a:%Address%" "/u:%Login%" "/p:%Password%" /timeout:%CheckTimeout% /q
if not "%ErrorLevel%"=="0" goto :Fail

echo  ^> Publishing %AppName%

del /Q "%Applications%\*.jcard">nul 2>&1
tadmin PackageApp "%Applications%\%AppName%\%AppName%.dll" /64bit /api2 "/a:tessadesktopapp" "/out:%Applications%\%AppName%.jcard" /q
if not "%ErrorLevel%"=="0" goto :Fail
tadmin PackageApp "%Applications%\%AppName%32\%AppName%.dll" /api2 "/a:tessadesktopapp" "/out:%Applications%\%AppName%32.jcard" /q
if not "%ErrorLevel%"=="0" goto :Fail
tadmin ImportCards "%Applications%" "/a:%Address%" "/u:%Login%" "/p:%Password%" /q
if not "%ErrorLevel%"=="0" goto :Fail
del /Q "%Applications%\*.jcard">nul 2>&1

call :Cleanup

echo;
echo %AppName% is published.
echo Press any key to close...
pause>nul
cls
goto :Finish

:Cleanup
goto :EOF

:Fail
echo;
call :Cleanup
echo Publication failed with error code: %ErrorLevel%
echo See the details in log file: %Tools%\log.txt
echo;
echo Press any key to close...
pause>nul
cls
goto :Finish

:Finish
endlocal
goto :EOF