﻿using Tessa.Extensions.Default.Client.Initialization;
using Tessa.Extensions.Platform.Client.Application;
using Tessa.Extensions.Platform.Client.Initialization;
using Tessa.Extensions.Platform.Shared.Initialization;
using Tessa.Extensions.Shared;
using Tessa.Platform.Initialization;
using Tessa.Platform.Runtime;

namespace Tessa.Extensions.Client.TessaDesktopApp
{
    [Registrator]
    public sealed class Registrator : RegistratorBase
    {
        public override void RegisterExtensions(IExtensionContainer extensionContainer)
        {
            extensionContainer
                .RegisterExtension<IClientInitializationExtension, KrClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, CardClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, LicenseClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, SingletonClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IApplicationExtension, ClientApplicationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IApplicationExtension, FileFinalizationApplicationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, LocalizationClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, ViewClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, SearchQueryClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, WorkplaceClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, FileTemplatesClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, PasswordExpiresSoonNotificationInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IClientInitializationExtension, ForumClientInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
            ;
        }
    }
}
