﻿using Tessa.Platform.Initialization;
using Tessa.Platform.Runtime;
using Tessa.Extensions.Shared;
using Unity;

namespace Tessa.Extensions.Server.Initialization
{
    [Registrator]
    public sealed class Registrator : RegistratorBase
    {
        public override void RegisterUnity()
        {
            this.UnityContainer.RegisterType<AbUserAccessServerInitializationExtension>(TypeLifetime.ContainerControlled);
        }

        public override void RegisterExtensions(IExtensionContainer extensionContainer)
        {
            extensionContainer
                .RegisterExtension<IServerInitializationExtension, AbUserAccessServerInitializationExtension>(x => x
                    .WithOrder(ExtensionStage.AfterPlatform)
                    .WithUnity(this.UnityContainer)
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp));
        }
    }
}
