﻿using Tessa.Extensions.Default.Server.Initialization;
using Tessa.Extensions.Default.Server.Workflow.KrProcess.Initialization;
using Tessa.Extensions.Platform.Server.Initialization;
using Tessa.Extensions.Shared;
using Tessa.Platform.Initialization;
using Tessa.Platform.Runtime;

namespace Tessa.Extensions.Server.TessaDesktopApp
{
    [Registrator]
    public sealed class Registrator : RegistratorBase
    {
        public override void RegisterExtensions(IExtensionContainer extensionContainer)
        {
            extensionContainer
                .RegisterExtension<IServerInitializationExtension, KrServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, GlobalButtonsInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, CheckVersionServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, LocalizationServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, ViewServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, SearchQueryServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, WorkplaceServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, CardServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, LicenseServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, SingletonServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, FileTemplatesServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, ForumServerInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, PasswordExpiresSoonInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                .RegisterExtension<IServerInitializationExtension, UserCipherInfoInitializationExtension>(x => x
                    .WhenApplications(AbApplicationIdentifiers.TessaDesktopApp))
                ;
        }
    }
}
